Package org.apache.commons.io.input

# Class MessageDigestInputStream.Builder

java.lang.Object
org.apache.commons.io.build.AbstractSupplier<ObservableInputStream,MessageDigestInputStream.Builder>
org.apache.commons.io.build.AbstractOriginSupplier<ObservableInputStream,MessageDigestInputStream.Builder>
org.apache.commons.io.build.AbstractStreamBuilder<ObservableInputStream,MessageDigestInputStream.Builder>
org.apache.commons.io.input.ProxyInputStream.AbstractBuilder<ObservableInputStream,MessageDigestInputStream.Builder>
org.apache.commons.io.input.ObservableInputStream.AbstractBuilder<MessageDigestInputStream.Builder>
org.apache.commons.io.input.MessageDigestInputStream.Builder

All Implemented Interfaces:
  `IOSupplier<ObservableInputStream>`

Enclosing class:
  `MessageDigestInputStream`

public static class MessageDigestInputStream.Builder extends ObservableInputStream.AbstractBuilder<MessageDigestInputStream.Builder>
Builds new `MessageDigestInputStream`.

For example:

     MessageDigestInputStream s = MessageDigestInputStream.builder()
       .setPath(path)
       .setMessageDigest("SHA-512")
       .get();

You must specify a message digest algorithm name or instance.

The MD5 cryptographic algorithm is weak and should not be used.

See Also:
  - `get()`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `Builder()`
  Constructs a new builder of `MessageDigestInputStream`.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `MessageDigestInputStream`
  `get()`
  Builds new `MessageDigestInputStream`.
  `MessageDigestInputStream.Builder`
  `setMessageDigest(String algorithm)`
  Sets the name of the name of the message digest algorithm.
  `MessageDigestInputStream.Builder`
  `setMessageDigest(MessageDigest messageDigest)`
  Sets the message digest.

  ### Methods inherited from class org.apache.commons.io.input.ObservableInputStream.AbstractBuilder

  `setObservers`

  ### Methods inherited from class org.apache.commons.io.input.ProxyInputStream.AbstractBuilder

  `getAfterRead, setAfterRead`

  ### Methods inherited from class org.apache.commons.io.build.AbstractStreamBuilder

  `getBufferSize, getBufferSizeDefault, getCharSequence, getCharset, getCharsetDefault, getFile, getInputStream, getOpenOptions, getOutputStream, getPath, getRandomAccessFile, getReader, getWriter, setBufferSize, setBufferSize, setBufferSizeChecker, setBufferSizeDefault, setBufferSizeMax, setCharset, setCharset, setCharsetDefault, setOpenOptions`

  ### Methods inherited from class org.apache.commons.io.build.AbstractOriginSupplier

  `checkOrigin, getOrigin, hasOrigin, newByteArrayOrigin, newCharSequenceOrigin, newFileOrigin, newFileOrigin, newInputStreamOrigin, newOutputStreamOrigin, newPathOrigin, newPathOrigin, newRandomAccessFileOrigin, newRandomAccessFileOrigin, newReaderOrigin, newURIOrigin, newWriterOrigin, setByteArray, setCharSequence, setFile, setFile, setInputStream, setOrigin, setOutputStream, setPath, setPath, setRandomAccessFile, setRandomAccessFile, setReader, setURI, setWriter`

  ### Methods inherited from class org.apache.commons.io.build.AbstractSupplier

  `asThis`

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

  ### Methods inherited from interface org.apache.commons.io.function.IOSupplier

  `asSupplier, getUnchecked`

- ## Constructor Details

  - ### Builder

    public Builder()
    Constructs a new builder of `MessageDigestInputStream`.

- ## Method Details

  - ### get

    public MessageDigestInputStream get() throws IOException
    Builds new `MessageDigestInputStream`.

    You must set an aspect that supports `AbstractStreamBuilder.getInputStream()`, otherwise, this method throws an exception.

    This builder uses the following aspects:

    - `AbstractStreamBuilder.getInputStream()` gets the target aspect.
    - `MessageDigest`
    Returns:
      a new instance.
    Throws:
      `NullPointerException` - if messageDigest is null.
      `IllegalStateException` - if the `origin` is `null`.
      `UnsupportedOperationException` - if the origin cannot be converted to an `InputStream`.
      `IOException` - if an I/O error occurs converting to an `InputStream` using `AbstractStreamBuilder.getInputStream()`.
    See Also:
      - `AbstractStreamBuilder.getInputStream()`
      - `IOSupplier.getUnchecked()`

  - ### setMessageDigest

    public MessageDigestInputStream.Builder setMessageDigest(MessageDigest messageDigest)
    Sets the message digest.

    The MD5 cryptographic algorithm is weak and should not be used.

    Parameters:
      `messageDigest` - the message digest.
    Returns:
      `this` instance.

  - ### setMessageDigest

    public MessageDigestInputStream.Builder setMessageDigest(String algorithm) throws NoSuchAlgorithmException
    Sets the name of the name of the message digest algorithm.

    The MD5 cryptographic algorithm is weak and should not be used.

    Parameters:
      `algorithm` - the name of the algorithm. See the MessageDigest section in the Java Cryptography Architecture Standard Algorithm Name Documentation for information about standard algorithm names.
    Returns:
      `this` instance.
    Throws:
      `NoSuchAlgorithmException` - if no Provider supports a MessageDigestSpi implementation for the specified algorithm.